/**
 * UPDATES AND DOCS AT: https://github.com/wangyang0210
 * https://www.cnblogs.com/wangyang0210/
 * @author: WangYang, wangyang.0210@foxmail.com
 * @Date 2022-08-25 15:26
 * ----------------------------------------------
 * @describe: 主程序文件
 */
import _ from 'lodash';
import config from './components/config/config';
import status from "./components/status/status";
import tools from './utils/tools';
import event from "./components/event/event";

$(document).ready(function () {

    // 初始化
    _.__config = config(); // 配置信息
    _.__status = status(); // 页面状态信息
    _.__tools = tools();  // 公共处理工具
    _.__timeIds = {};       // 定时器
    _.__event = {};       // 事件


    if (_.__config.info.name === '') _.__config.info.name = _.__status.user;

    // 开启渲染
    import(/* webpackChunkName: "page-[request]" */ `./page/${_.__status.pageType}`).then(module => {
        const page = module.default;

        /**
         * 前置公共处理
         */
        import(/* webpackChunkName: "com-before" */ './components/common/comBefore').then(beforeModule => {
            const comBefore = beforeModule.default;
            comBefore(_);

            /**
             * 页面逻辑处理
             */
            page(_);

            /**
             * 后置公共处理
             */
            import(/* webpackChunkName: "com-after" */ './components/common/comAfter').then(afterModule => {
                const comAfter = afterModule.default;
                comAfter(_);
                (() => {
                    _.__tools.setDomHomePosition(); // 文章主体位置修正
                    event(_).handle.scroll(); // 触发滚动处理
                    event(_).handle.resize(); // 触发窗口大小变化处理
                })();
            });
        });
    });
})
